#pragma once

#include <iostream>
#include <fstream>
#include <algorithm>
#include <iterator>
#include <vector>
#include <deque>
#include <list>
#include <string>
#include <sstream>


void CreateData_stream() {
	std::ofstream fout("Data.txt");
	for (int i = 0; i < 100; ++i)
		fout << -50 + rand() % 101 << "\t";
}

void CreateData_generate() {
	std::vector<int> my_vector(100);
	std::generate(my_vector.begin(), my_vector.end(), []() {return -50 + rand() % 101; });
	std::ofstream fout("Data.txt", std::ios::app);
	std::ostream_iterator<int> fout_iter(fout, "\t");
	std::copy(my_vector.begin(), my_vector.end() - 1, fout_iter);
	fout << *(my_vector.end() - 1) << std::endl;
}



template<typename _container>
_container LoadData_stream(const std::string& filename) {
	_container a_container;
    // ПЕРЕД ЗАВИСИМЫМ ТИПОМ НАДО УКАЗЫВАТЬ КЛЮЧЕВОЕ СЛОВО typename
	using value_type = _container::value_type;
	std::ifstream fin(filename);
	if (!fin) {
		std::cerr << "CAN'T OPEN FILE" << std::endl;
        // ЭТО ЧТО ТАКОЕ?
        exit;
	}
	std::string line;
	while (std::getline(fin, line, '\t')) {
		std::istringstream iss(line);
		value_type el;
        // ЧИТАТЬ НАДО ОПЕРАТОРОМ ПОТОКА ИЗ ФАЙЛА,
        // ПРОМЕЖУТОЧНЫЙ ОБЪЕКТ istringstream В ДАННОМ СЛУЧАЕ НЕ НУЖЕН
		if (!(iss >> el))
			break;
		a_container.push_back(el);
	}
	for (const auto& el : a_container)
		std::cout << el << std::endl;
	return a_container;
}

template<typename _container>
_container LoadData_stream_iterator(const std::string& filename) {
    CreateData_stream;
	using value_type = _container::value_type;
	_container a_container(200);
	std::ifstream fin(filename);
	if (!fin) {
		std::cerr << "CAN'T OPEN FILE" << std::endl;
        // ?
        exit;
	}
	else {
		std::copy(std::istream_iterator<value_type>(fin), std::istream_iterator <value_type>(), a_container.begin());
		for (const auto& el : a_container)
			std::cout << el << std::endl;
		return a_container;
	}
}



template <typename _container>
_container template_modify(const _container& cont)
{
	typename _container::value_type biggest_num = *std::max_element(cont.begin(), cont.end());
	_container temp;
	for (auto& el : cont) {
		temp.push_back((el - biggest_num));
	}
	return temp;
}

template <typename _InputIter, typename _DesIter>
void it_modify(const _InputIter it_begin, const _InputIter it_end, _DesIter des_it) {
	typename _InputIter::value_type biggest_num = *std::max_element(it_begin, it_end);
	auto temp_it = des_it;
	for (auto it = it_begin; it != it_end; ++it)
		*(temp_it++) = *it - biggest_num;
}

template <typename _container>
void ForEach_modify(_container& cont) {
	using m_type = typename _container::value_type;
	m_type biggest_num = *std::max_element(cont.begin(), cont.end());
    // В ЛЯМБДА ФУНКЦИЮ НУЖНО ПЕРЕДАВАТЬ biggest_num ПО ЗНАЧЕНИЮ
	auto modify = [&](typename _container::value_type& el) {
		el -= biggest_num;
		return el;
	};
	std::for_each(cont.begin(), cont.end(), modify);
}

void transform_modify(const std::string& in_filename, const std::string& out_filename) {
	std::ifstream fin(in_filename);
	std::ofstream fout(out_filename, std::ios::app);
	if (!fin)
		std::cerr << "CAN'T OPEN FILE" << std::endl;
	else {
		std::vector<int> vec(200);
		std::copy(std::istream_iterator<int>(fin), std::istream_iterator<int>(), vec.begin());
		auto biggest_num = *std::max_element(vec.begin(),vec.end());
		std::cout << "MAX: " << biggest_num << std::endl;
        // В ЛЯМБДА ФУНКЦИЮ НУЖНО ПЕРЕДАВАТЬ biggest_num ПО ЗНАЧЕНИЮ
        auto modify = [&](auto& el) {
			return (el - biggest_num);
		};
		std::transform(vec.begin(), vec.end(), std::ostream_iterator<int>(fout, "\t"), modify);
		fout << std::endl;
	}
}



template <typename _container>
void OutResultStream(const std::string& filename, const _container& container) {
	std::ofstream fout(filename, std::ios::app);
	for (const auto& el : container)
		fout << el << "\t";
	fout << std::endl;
}

template <typename _container>
void OutResultCopy(const std::string& filename, const _container& container) {
	using a_type = typename _container::value_type;
	std::ofstream fout(filename, std::ios::app);
	std::copy(container.begin(), container.end(), std::ostream_iterator<a_type>(fout, "\t"));
	fout << std::endl;
}



