#pragma once
#include <string>
#include <map>
#include <any>
#include <vector>
#include <initializer_list>

struct subject {
	char sub_name[128];
	char teacher_name[128];
	int sub_id;
	int group_id;
	int num_of_st;
	float lecture_hours;
	float practice_hours;
	bool availability;
	char type_control[8];

	subject() = default;
	subject(const char*, const char*, int, int, int, bool, const char*);
	static void GetHours(subject&);
	friend std::istream& operator >> (std::istream& s_in, subject& subj);
	friend std::ostream& operator << (std::ostream& s_out, const subject& subj);
};

class function
{
public:
	using map_array = std::map<int, subject>;
	function(const std::string&);
	void CreateFile();
	void Add(const std::initializer_list<subject>&);
	void Delete(int);
	void Replace(int, const subject&);
	void TransformToText();
	void Search_by_teacher(const std::string&);
	void Search_by_group_id(int);
	void Search_by_availability(bool);
	void Search_by_type_control(const std::string&);
private:
	std::string filename;
	bool first_create = 0;
	map_array m_arr;
	void GetData();

};